package de.edotzlaff.detection.detektion;


import android.os.Build;
import androidx.annotation.RequiresApi;
import de.edotzlaff.detection.detektion.berechnung.Endpunkt;
import de.edotzlaff.detection.detektion.berechnung.EndpunktVerbindung;
import de.edotzlaff.detection.detektion.berechnung.EpizentrumRechnung;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Objects;


public class Erdbeben {

    public int geschwErdbeben = 1;

    private Epizentrum epizentrum;
    private EpizentrumRechnung epizentrumRechnung;
    private HashMap<String, Detektionssignal> nutzerDaten;

    public Erdbeben() {

        nutzerDaten = new HashMap<>();
        epizentrumRechnung = new EpizentrumRechnung();
        epizentrum = new Epizentrum();
    }

    public int addDetektionssignal(Detektionssignal detektionssignal) {
        nutzerDaten.put(detektionssignal.getDeviceId(), detektionssignal);
        return nutzerDaten.size();
    }

    public void addDetektionssignalList(ArrayList<Detektionssignal> detektionssignale)
    {
        for (int i = 0; i< detektionssignale.size(); i++)
        {
            nutzerDaten.put(detektionssignale.get(i).getDeviceId(),detektionssignale.get(i));
        }
    }

    @RequiresApi(api = Build.VERSION_CODES.O)
    public Epizentrum ermittleEpizentrum() {

        ArrayList<Detektionssignal> rechenListe = new ArrayList<>();
        nutzerDaten.forEach((key, value) -> rechenListe.add(value));
        //Initialisierung der Rechung - First Element mit delta r + alle möglichen EndpunktKombinationen (einfach)
        ArrayList<Endpunkt> berechnungsEndpunkte = epizentrumRechnung.initEndpunkte(rechenListe);
        ArrayList<EndpunktVerbindung> endpunktKonbinationen = epizentrumRechnung.ermittleEndpunktKonbinationen(berechnungsEndpunkte);

        //ToDo Vernünftiger Endpunkt überlegen bzw. bis wann abgebrochen wird -> Umzug in Berechnungs
        for (int i = 0; i <= 600; i++) {
            if (epizentrumRechnung.genuegendSchnittpunktevorhanden(endpunktKonbinationen)) {
                epizentrum = epizentrumRechnung.ueberpruefeObEpizentrum(endpunktKonbinationen);
                //ToDo set EnstehungsZeitpunkt -> (Bezugszeit, Koord, Koord, v;)
                if (!Objects.isNull(epizentrum)) {
                    System.out.println("Epizentrum ermittelt");
                    epizentrum.setEntstehungsZeitpunkt(
                            epizentrumRechnung.berechneEntstehungsZeitpunkt(
                                    nutzerDaten.get(berechnungsEndpunkte.get(0).getNutzer()), epizentrum.getKoordinaten()));
                    return epizentrum;
                }
            }
            epizentrumRechnung.erhoheRadius(berechnungsEndpunkte);
        }
        return null;
    }

}
